import pygame, random

class Force(object):
    def __init__(self,redtime=0,bluetime=0,redchange=0,bluechange=0):
        self.redtimeleft = redtime
        self.bluetimeleft = bluetime
        
        if self.redtimeleft > 0:
            self.redchangeamt = float(redchange)/self.redtimeleft
        elif self.redtimeleft == -1:
            self.redchangeamt = float(redchange)/60 #Calculate it for per second
        else:
            self.redchangeamt = 0.0
        
        if self.bluetimeleft > 0:
            self.bluechangeamt = float(bluechange)/self.bluetimeleft
        elif self.bluetimeleft == -1:
            self.bluechangeamt = float(bluechange)/60 #Calculate it for per second
        else:
            self.bluechangeamt = 0.0
            
        if min(self.redtimeleft,self.bluetimeleft) == -1:
            self.timeleft = -1
        else:
            self.timeleft = max(self.redtimeleft,self.bluetimeleft)
    
    def update(self):
        if self.redtimeleft > 0:
            self.redtimeleft -= 1
        if self.bluetimeleft > 0:
            self.bluetimeleft -= 1
        if self.timeleft > 0:
            self.timeleft -= 1
        
        if self.redtimeleft == 0:
            self.redchangeamt = 0.0
        if self.bluetimeleft == 0:
            self.bluechangeamt = 0.0
    
    def __repr__(self):
        rstr = "Force object, rt:%d bt: %d - rca:%f bca %f"
        return rstr%(self.redtimeleft,self.bluetimeleft,
                    self.redchangeamt,self.bluechangeamt)

class Buyable(object):
    def __init__(self,income=0,force="",dispname="None",dispimg="media/default.png",price=0,id=0,priceinc=1.2):
        self.displayname = dispname
        self.income = income
        self.force = force
        self.baseprice = price
        self.currentprice = price
        self.priceinc = priceinc
        self.dispimg = pygame.image.load(dispimg).convert_alpha()
    
    def adjustprice(self,currentamt):
        self.currentprice = self.baseprice
        if currentamt == 0:
            return
            
        for i in xrange(currentamt+1):
            self.currentprice += self.priceinc ** i
    

class Moon(object):
    def __init__(self):
        #Tiered random, makes sure it is always 50 badness
        self.red = float(random.randint(0,50))
        self.blue = 50-self.red
        
        self.forces = []
        
        self.load()
        self.update()
    
    def load(self):
        #http://natyjonasproductions.deviantart.com/art/Moon-PNG-276593947
        self.mainimg = pygame.image.load("media/moon.png").convert()
        self.redimg = pygame.image.load("media/moonRed.png").convert()
        self.blueimg = pygame.image.load("media/moonBlue.png").convert()
        
    def update(self):
        for f in self.forces:
            self.red = max(self.red+f.redchangeamt,0)
            self.blue = max(self.blue+f.bluechangeamt,0)
            f.update()
            if f.timeleft == 0:
                self.forces.remove(f)
            
        self.redimg.set_alpha(self.red)
        self.blueimg.set_alpha(self.blue)